package com.trustpayments.mobile.core.models.api.response

enum class ResponseErrorCode(val code: Int) {
    Ok(0),
    GenericError(1),
    TrustPaymentsAPIRequiresTheRequestsLibrary(2),
    SendError(4),
    ReceiveError(5),
    InvalidCredentialsProvided(6),
    AnIssueOccuredWhilstTryingToConnectToTrustPaymentsServers(7),
    UnexpectedErrorConnectingToTrustPaymentsServers(8),
    UnknownError(9),
    IncorrectUsageOfTheTrustPaymentsAPI(10),
    InvalidCardDetails(10003),
    InvalidDate(10100),
    InvalidDateTime(10101),
    InvalidDetails(10102),
    CardNumberDoesNotMatchCardType(10103),
    MalformedXML(10200),
    XMLDoesNotMatchSchema(10201),
    InvalidFileFormat(10202),
    EmptyFileContents(10203),
    InvalidFileContents(10204),
    MalformedJSON(10205),
    StApiError(10500),
    InvalidFieldsSpecifiedInRequest(10600),
    MissingParent(20004),
    RefundRequiresSettledParentOrParentThatsDueToSettleToday(20005),
    RefundRequiresAuthorisationParent(20006),
    RefundAmountTooGreat(20007),
    NoAcquirerSpecified(20008),
    RepeatAmountTooGreat(20009),
    SplitAmountTooGreat(20010),
    CannotRefundADeclineTransaction(20011),
    RefundRequiresASettledParent(20012),
    ReversalRequiresACancelledAuthParent(20013),
    CannotOverrideAmountInChildTransaction(20014),
    CannotOverrideCurrencyInChildTransaction(20015),
    SubscriptionRequiresRECURAccount(20018),
    SubscriptionRequiresSuccessfulParent(20019),
    RiskDecisionsMustHaveAUTHAsParent(20020),
    ChargebacksMustHaveAUTHREFUNDAsParent(20021),
    RefundAmountLessThanMinimumAllowed(20022),
    RefundRequiresPaypaltransactionid(20023),
    InvalidSplitTransaction(20024),
    CannotReverseAUTHProcessedMoreThan48HoursAgo(20025),
    ReversalRequiresAcquirerreferencedata(20026),
    CannotReverseAUTHProcessedByADifferentAcquirer(20027),
    PaymentTypeDoesNotSupportRepeats(20028),
    ReversalMissingRequiredData(20029),
    MissingToken(20030),
    SubscriptionWithAnAccountcheckParentNotSupportedOnCurrentAcquirer(20031),
    SubscriptionCannotBeUsedAsAParent(20032),
    InvalidParent(20033),
    PaymentTypeDoesNotSupportRefunds(20034),
    InvalidIncrementalTransaction(20035),
    PartialReversalsNotSupported(20036),
    THREEDQUERYParentChildMustHaveTheSamePaymenttypeAsTheChild(20037),
    PaymentTypeDoesNotSupportCardSchemeUpdates(20038),
    CannotReverseAUTHAtThisTime(20039),
    ServiceTemporarilyDisabled(21000),
    LoginFirstrequest(21001),
    InvalidUsernamePassword(21002),
    InvalidSession(21003),
    SessionHasExpired(21004),
    PasswordExpired(21005),
    PasswordHasBeenPreviouslyUsed(21006),
    AccountHasBeenLocked(21007),
    NewPasswordDoesNotMatchConfirmedPassword(21009),
    IncorrectCurrentPassword(21010),
    InvalidSelection(21012),
    UserAlreadyExists(21013),
    NoTransactionFound(21014),
    InvalidSelectedTransactions(21015),
    DataSuppliedHasNotBeenSaved(21016),
    InvalidRequestType(21017),
    MissingRequestTypeAtLeastOneRequestTypeMustBeSelected(21018),
    InvalidPaymentType(21019),
    MissingPaymentTypeAtLeastOnePaymentTypeMustBeSelected(21020),
    InvalidErrorCode(21021),
    MissingErrorCodeAtLeastOneErrorCodeMustBeSelected(21022),
    InvalidFilterDescription(21023),
    InvalidDestinationDescription(21024),
    InvalidNotificationType(21025),
    InvalidDestination(21026),
    InvalidFieldSelected(21027),
    InvalidEmailFromAddress(21028),
    InvalidEmailSubject(21029),
    InvalidEmailEmailType(21030),
    UnableToProcessRequest(21031),
    NoFileSelectedForUpload(21032),
    InvalidFileSize(21033),
    InvalidFilename(21034),
    InvalidExtension(21035),
    UserRequiresAtLeastOneSitereference(21036),
    OnlySTlevelUsersCanHaveAccess(21037),
    RequestFailed(21038),
    InvalidFileContents2(21039),
    MaximumNumberOfFilesUploaded(21040),
    InsufficientGatewayAccessPrivileges(21041),
    MaximumFileSizeLimitReached(21042),
    UsernameMustBeAValidUser(21043),
    SitereferenceMustBeAValidSite(21044),
    UnableToSendEmail(21045),
    NegativeAlreadyExists(21046),
    CannotDeleteASearchOwnedByAnotherUser(21047),
    InvalidSearch(21048),
    CannotDeleteTheSpecifiedSearch(21049),
    SearchParameterIsTooShort(21050),
    DuplicateCustomFieldsDefined(21051),
    CannotAllocateSelectedUsersInsufficientPrivileges(21052),
    AllocatedUsersHaveAccessToAdditionalSites(21053),
    AllocatedUsersHaveAccessToAdditionalUsers(21054),
    UserWithCurrentRoleCannotBeAllocatedUsers(21055),
    ThisSiteRequiresThatYourBrowserAcceptCookiesToSignIn(21056),
    UserRequiresAtLeastOneSiteReferenceOrSiteGroup(21057),
    AllocatedUsersHaveAccessToAdditionalSiteGroups(21058),
    Bypass(22000),
    InsufficientAccessPrivileges(25000),
    CodingError(25001),
    InsufficientPrivileges(25002),
    InvalidRequest(25003),
    InvalidField(30000),
    UnknownSite(30001),
    BannedCard(30002),
    XmlElementParseError(30003),
    MaestroMustUseSecureCode(30004),
    MultipleEmailAddressesMustBeSeparatedWithCommaOrSemicolon(30005),
    InvalidSitereferenceForAlias(30006),
    InvalidVersionNumber(30007),
    UnknownUser(30008),
    CannotDetermineAccount(30009),
    JsonElementParseError(30010),
    WalletTypeConfigurationError(30011),
    WalletTypeNotSupportedOnThisRequest(30012),
    TheCardNumberYouHaveProvidedIsIncorrect(31000),
    TheSecurityCodeCVV2YouHaveProvidedIsIncorrect(31001),
    TheExpiryDateYouHaveProvidedIsIncorrect(31002),
    TheExpiryMonthYouHaveProvidedIsIncorrect(31003),
    TheExpiryYearYouHaveProvidedIsIncorrect(31004),
    UnableToProcessYourPaymentDueToConnectionErrorsRequestIdMismatch(31005),
    TheIssueNumberYouHaveProvidedIsIncorrect(31006),
    ThePaymentTypeYouHaveProvidedIsIncorrect(31007),
    UnableToProcessYourPayment(31009),
    ThereAreErrorsWithTheseFields(31010),
    NoAccountFound(40000),
    RefundCannotBeProcessed(40001),
    TransactionDeactivated(40002),
    SocketReceiveError(50000),
    SocketConnectionError(50001),
    SocketClosed(50002),
    InvalidDataReceived(50003),
    InvalidSQL(50004),
    Timeout(50005),
    InvalidAcquirer(50006),
    UnableToConnectToAcquirer(50007),
    InvalidResponseFromAcquirer(50008),
    NoAvailableTransport(50009),
    FileSizeTooLarge(50010),
    SocketSendError(50011),
    CommunicationError(50012),
    ProxyError(50014),
    UnableToProcessYourPaymentDueToConnectionErrors(51000),
    UnableToProcessYourPaymentDueToConnectionErrors2(51001),
    WrongNumberOfEmails(60003),
    BankSystemError(60010),
    WrongNumberOfTransactions(60011),
    InvalidTransportConfiguration(60012),
    NoValidUpdatesSpecified(60013),
    TransactionReferenceNotFound(60014),
    SettlebaseamountTooLarge(60016),
    TransactionNotUpdatable(60017),
    InvalidRequesttype(60018),
    NoSearchableFilterSpecified(60019),
    TimeoutError(60020),
    ThreeDSecureTransportError(60021),
    Unauthenticated(60022),
    SiteSuspended(60023),
    NoUpdatesPerformed(60024),
    InvalidRequest2(60025),
    InvalidResponse(60026),
    InvalidAcquirer2(60027),
    InvalidAccountData(60028),
    Missing(60029),
    PaymentError(60030),
    InvalidAcquirerForThreeDSecure(60031),
    InvalidPaymentTypeForThreeDSecure(60032),
    InvalidUpdatesSpecified(60033),
    ManualInvestigationRequired(60034),
    InvalidHeaders(60035),
    MaxFraudscoreExceeded(60036),
    InvalidFilters(60037),
    MerchantSystemError(60038),
    YourPaymentIsBeingProcessed(60039),
    CanNotSpecifyBothRequesttypedescriptionAndRequesttypedescriptionsOnASingleRequest(60040),
    AcquirerMissingOriginalTransactionData(60041),
    InvalidProcess(60100),
    InvalidProcess2(60101),
    InvalidProcess3(60102),
    InvalidProcess4(60103),
    InvalidProcess5(60104),
    InvalidProcess6(60105),
    InvalidProcess7(60106),
    InvalidProcess8(60107),
    InvalidProcess9(60108),
    InvalidProcess10(60109),
    InvalidProcess11(60110),
    InvalidProcess12(60111),
    InvalidProcess13(60112),
    InvalidProcess14(60113),
    InvalidProcess15(60114),
    InvalidProcess16(60115),
    InvalidProcess17(60116),
    InvalidProcess18(60117),
    InvalidProcess19(60118),
    InvalidProcess20(60119),
    InvalidProcess21(60120),
    NamePickRequired(61000),
    AddressPickRequired(61001),
    IPNotInRange(61002),
    InvalidButtonConfiguration(61003),
    UnrecognisedResponseFromAcquirer(62000),
    Decline(70000),
    UncertainResult(70001),
    ThereHasBeenAProblemWithYourPayment(99998),
    UnknownError2(99999),
    
    Other(-1)
}